
precision lowp float;

uniform sampler2D tex;

uniform lowp samplerCube texCubeMap;

uniform lowp sampler2D texSpecular;

varying lowp vec3 v_v3Normal;
varying mediump vec3 v_v3WorldPosition;

uniform lowp float u_fBrightness;
uniform lowp float u_fSpecular;
uniform mediump vec3 u_v3EyePosition;

varying vec2 v_v2TexCoord;
varying vec4 v_v4Color;

void main() 
{
	vec4 v4Texture = texture2D(tex, v_v2TexCoord) * v_v4Color;
	
	mediump vec3 v3Incident = v_v3WorldPosition - u_v3EyePosition;
	mediump vec3 v3Reflection = v3Incident - 2.0 * dot(v3Incident, v_v3Normal) * v_v3Normal / dot(v_v3Normal, v_v3Normal);	
	lowp vec4 v4TextureCube = textureCube(texCubeMap, v3Reflection);

	lowp float fSpec = u_fSpecular * ((v4Texture.r + v4Texture.g + v4Texture.b) * 0.333);
	lowp vec4 v4Tmp1 = vec4(v4Texture.rgb + v4TextureCube.rgb * u_fSpecular * fSpec, v4Texture.a);
	
	lowp vec4 v4Tmp2 = 1.0 - v4Tmp1;
	gl_FragColor = v4Tmp1 * (2.0 - u_fBrightness) + (1.0 - v4Tmp2 * v4Tmp2 * v4Tmp2) * (u_fBrightness - 1.0);	
}
