

uniform mat4 u_m44ModelViewProjection;
uniform float u_fZOffset;
uniform float u_fZClamp;
uniform float u_fMinZOffset; 
uniform float u_fAlphaLevel;

attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;
attribute vec4 a_v4Color;
attribute vec3 a_v3Normal;

varying vec2 v_v2TexCoord;
varying vec4 v_v4Color;

varying lowp vec3 v_v3Normal;
varying mediump vec3 v_v3WorldPosition;

void main() 
{
	v_v2TexCoord = a_v2TexCoord;
	v_v4Color = a_v4Color * (1.0 / 255.0);
	v_v4Color.a *= u_fAlphaLevel;
	
	v_v3Normal = a_v3Normal;
	v_v3WorldPosition = a_v4Position.xyz;
	
	gl_Position = u_m44ModelViewProjection * a_v4Position;
	float fDiv = gl_Position.w;
	if (fDiv < u_fZClamp)
		fDiv = u_fZClamp;
	float zOffset = u_fZOffset / fDiv;
	if (zOffset < u_fMinZOffset)
		zOffset = u_fMinZOffset;
	gl_Position.z -= zOffset;
}

