
precision lowp float;

uniform sampler2D tex;
uniform lowp samplerCube texCubeMap;

uniform lowp float u_fSpecular;
uniform lowp float u_fRewindEffect;

varying vec2 v_v2TexCoord;
varying vec4 v_v4Color;

varying mediump vec3 v_v3Reflection;

void main() 
{
	vec4 v4Texture = texture2D(tex, v_v2TexCoord) * v_v4Color;
	lowp vec4 v4TextureCube = textureCube(texCubeMap, v_v3Reflection);
	lowp float fSpec = u_fSpecular * ((v4Texture.r + v4Texture.g + v4Texture.b) * 0.333);

	gl_FragColor = vec4((v4Texture.rgb + v4TextureCube.rgb * fSpec) * (1.0 - u_fRewindEffect) + v4Texture.b * u_fRewindEffect, v4Texture.a);
}
