
uniform mat4 u_m44ModelViewProjection;


attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;
attribute vec2 a_v2TexCoord3;

varying mediump vec2 v_v2TexCoord;
varying mediump vec2 v_v2LightTexCoord;


#ifndef DETAIL_LOW
	uniform mat3 u_m33SpecularRotation;

	attribute vec3 a_v3Normal;

	#ifdef COMPOSIT_CHANNELS
		attribute vec4 a_v4Color;
		attribute vec4 a_v4Color2;

		varying mediump vec4 v_v4Color;
		varying mediump vec4 v_v4Color2;
	#endif

	varying lowp vec3 v_v3Normal;
	varying lowp vec3 v_v3WorldPosition;
#endif //#ifndef DETAIL_LOW

#ifdef Z_OFFSET
	uniform float u_fZOffset;
	uniform float u_fZClamp;
	uniform float u_fMinZOffset; 
#endif

void main() 
{
	v_v2TexCoord = a_v2TexCoord;
	v_v2LightTexCoord = a_v2TexCoord3;
	

	gl_Position = u_m44ModelViewProjection * a_v4Position;
	#ifdef Z_OFFSET
		float fDiv = gl_Position.w;
		if (fDiv < u_fZClamp)
			fDiv = u_fZClamp;
		float zOffset = u_fZOffset / fDiv;
		if (zOffset < u_fMinZOffset)
			zOffset = u_fMinZOffset;
		gl_Position.z -= zOffset;
	#endif
	
	#ifndef DETAIL_LOW

		#ifdef COMPOSIT_CHANNELS
			v_v4Color = a_v4Color * (1.0 / 255.0);
			v_v4Color2 = a_v4Color2 * (1.0 / 255.0);
		#endif

		v_v3Normal = a_v3Normal * u_m33SpecularRotation;
		v_v3WorldPosition = a_v4Position.xyz * u_m33SpecularRotation;
	#endif //#ifndef DETAIL_LOW
}

