precision lowp float;

uniform lowp sampler2D tex;
uniform lowp sampler2D texLightmap;

uniform lowp samplerCube texCubeMap;

uniform lowp sampler2D texSpecular;

varying mediump vec2 v_v2TexCoord;
varying mediump vec2 v_v2LightTexCoord;

varying mediump vec3 v_v3Reflection;

uniform lowp float u_fBrightness;
uniform mediump vec3 u_v3EyePosition;

void main() 
{
	lowp vec4 v4Light = texture2D(texLightmap, v_v2LightTexCoord);
	lowp vec4 v4Texture = texture2D(tex, v_v2TexCoord) * v4Light;
	
	lowp float fSpecular = texture2D(texSpecular, v_v2TexCoord).g;// * ((v4Light.r + v4Light.g + v4Light.b) * 0.333);

	lowp vec4 v4TextureCube = textureCube(texCubeMap, v_v3Reflection);

	gl_FragColor = v4Texture + v4TextureCube * fSpecular;
}


