
precision lowp float;

uniform lowp sampler2D tex;
uniform lowp sampler2D texLightmap;
uniform lowp samplerCube texCubeMap;
uniform lowp sampler2D texSpecular;

varying mediump vec2 v_v2TexCoord;
varying mediump vec2 v_v2LightTexCoord;
varying lowp vec3 v_v3Normal;
varying mediump vec3 v_v3WorldPosition;

uniform lowp float u_fBrightness;
uniform mediump vec3 u_v3EyePosition;
uniform float u_fAlphaLevel;

void main() 
{
	lowp vec4 v4Light = texture2D(texLightmap, v_v2LightTexCoord);
	lowp vec4 v4Texture = texture2D(tex, v_v2TexCoord) * v4Light;
	
	lowp float fSpecular = texture2D(texSpecular, v_v2TexCoord).g; // * ((v4Light.r + v4Light.g + v4Light.b) / 3.0);	
	
	mediump vec3 v3Incident = v_v3WorldPosition - u_v3EyePosition;
	mediump vec3 v3Reflection = v3Incident - 2.0 * dot(v3Incident, v_v3Normal) * v_v3Normal / dot(v_v3Normal, v_v3Normal);	
	lowp vec4 v4TextureCube = textureCube(texCubeMap, v3Reflection);

	lowp vec4 v4Tmp1 = (v4Texture + v4TextureCube * fSpecular);	
	v4Tmp1.w *= u_fAlphaLevel;

	lowp vec4 v4Tmp2 = 1.0 - v4Tmp1;
	gl_FragColor = v4Tmp1 * (2.0 - u_fBrightness) + (1.0 - v4Tmp2 * v4Tmp2 * v4Tmp2) * (u_fBrightness - 1.0);	
}


