
uniform mat4 u_m44ModelViewProjection;
uniform float u_fZOffset;
uniform float u_fZClamp;
uniform float u_fMinZOffset; 
uniform float u_fAlphaLevel;

uniform mat3 u_m33SpecularRotation;


attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;
attribute vec3 a_v3Normal;

attribute vec2 a_v2TexCoord3;


varying mediump vec2 v_v2TexCoord;
varying mediump vec2 v_v2LightTexCoord;

varying lowp vec3 v_v3Normal;
varying mediump vec3 v_v3WorldPosition;

void main() 
{
	v_v2TexCoord = a_v2TexCoord;
	v_v2LightTexCoord = a_v2TexCoord3;


	gl_Position = u_m44ModelViewProjection * a_v4Position;

	v_v3Normal = a_v3Normal * u_m33SpecularRotation;
	v_v3WorldPosition = a_v4Position.xyz * u_m33SpecularRotation;

	float fDiv = gl_Position.w;
	if (fDiv < u_fZClamp)
		fDiv = u_fZClamp;
	float zOffset = u_fZOffset / fDiv;
	if (zOffset < u_fMinZOffset)
		zOffset = u_fMinZOffset;
	gl_Position.z -= zOffset;
}

