precision lowp float;

uniform lowp sampler2D tex;
uniform lowp sampler2D texLightmap;

varying mediump vec2 v_v2TexCoord;
varying mediump vec2 v_v2LightTexCoord;

varying mediump vec3 v_v3Reflection;

uniform lowp float u_fRewindEffect;

uniform lowp float u_fBrightness;
uniform mediump vec3 u_v3EyePosition;

void main() 
{
	lowp vec4 v4Light = texture2D(texLightmap, v_v2LightTexCoord);
	lowp vec4 v4Texture = texture2D(tex, v_v2TexCoord) * v4Light;
	
	gl_FragColor = v4Texture * (1.0 - u_fRewindEffect) + v4Texture.b * u_fRewindEffect;
}


